@simulation prog for Bull and Bear Markets@

@Algorithm Described in A simple Framework for Understanding Bull
and Bear Markets@


@  This program is an amalgam of Watson's 91 and 93 progs@


@rules used are those in Dow Theory@
@it eliminates all smoothing@ 

@define output file@

@output from each replication of the 8 statistics is saved on line 207 into@
@file c:\bbjaeprog\pvals.dat; this should be changed to suit the user@

@line 22 saves the average of the statistics to c:\bbjaeprog\stkcyc.out;@
@Again this may need to be changed@

output file=c:\bbjaeprog\stkcyc.out reset;
output on;


@For simulation programs it is the total no of obs that is important so
one could just supply that but for the exercises in the paper it was
easier to derive them form dates chosen for estimation. In fact it is
only the characteristics of the "sample" that are important. Its best
to make the total and sample characteristics i.e. year/month the same
just in case I have used synbols like ndfy and nsfy interchangeably@


ndfy = 1960;             @ First Year of data set @
ndfm = 1;                @ First Month of data set @
ndly = 1992;             @ Last Year of data set @
ndlm = 6;                @ Last Month of data set @

nsfy = 1960;              @ First Year of Sample (Used in Analysis) @
nsfm = 1;                 @ First Month of Sample @
nsly = 1992;              @ Last Year of Sample @
nslm = 6;                @ Last Month of Sample @



nd= 12*(ndly-1-ndfy) + (13-ndfm) + (ndlm);     @ Number of data points @


cal=zeros(nd,1);

st=zeros(nd,1);


durs=zeros(nd,1);


ns1= 12*(nsfy-1-ndfy) + (13-ndfm) + (nsfm);    @ First Sample Point @
nd= 12*(nsly-1-nsfy) + (13-nsfm) + (nslm);  @ Number of data points - Sample @

 
durs=zeros(nd,1);bcp5=zeros(nd,1);bct5=zeros(nd,1);st=zeros(nd,1);


pds=zeros(1,1);tds=zeros(1,1);
pdsa=zeros(1,1);tdsa=zeros(1,1);

pdm=0;
pdma=0;
ppm=0;
ttm=0;
tdm=0;
tdma=0;
str=0;
spk=0;

@set no of replications for monte carlo work@

nrep=10;

vtr=0;
vpk=0;
pdcm=0;
tdcm=0;
tdem=0;
tdema=0;

pdem=0;
pdema=0;

tc1=0;
tc2=0;

tsave1=zeros(nrep,10);


pdmmat=zeros(nrep,1);tdmmat=zeros(nrep,1);
pdmmata=zeros(nrep,1);tdmmata=zeros(nrep,1);

@set icensor@
@icensor =0 if no censoring =1 if is@


icensor=0;

@iseed=92693370; used for most exper in bandb@

iseed=67844659;
ibomb=1;

@ibomb is set at replication before bombed out@

@enables one to study why it happened as it generates the
right random no@

@gen occurs if only 1 peak or trough in series. This happens if trend is
very strong real to std dev of shock@



@ibomb=1;
i=1;
do while i<=ibomb;
e=rndns(nd,1,iseed);
i=i+1;
endo;@



iter=ibomb;
do while iter<=nrep;

@gen 1000 more obs than needed to get rid of initial cond effect@

nd=nd+1000;
"iter= ";iter;

@need to choose which model to generate data from. They are all in procs
that have same form@

@cochrane campbell was done with separate program@



@Maheu-MCCurdy DDMS-DD model@

@{x,iseed}=ddmsdd(iseed);@

@random walk models@

@{x,iseed}=rwdata(iseed);@

@gordon st armour model@

@{x,iseed}=gordon(iseed);@



@garch and e-garch models@

@{x,iseed}=garch(iseed);@
{x,iseed}=egarch(iseed);





@reduce sample back to original size@


xa=x;
x=xa[1001:nd];


nd=nd-1000;


findates(x[1:nd],nd);


iter=iter+1;
endo;


"statistics on average cycle";
"contractions/expansions";

"durations";

meanc(tsave1[.,1:2]);

"amplitudes";

meanc(tsave1[.,3:4]);

"cumulative movements";

meanc(tsave1[.,5:6]);

"excess movements ";

meanc(tsave1[.,7:8]);


"fraction of bear <20;bull>20";

meanc(tsave1[.,9:10]);

i=1;
output file=c:\bbjaeprog\pvals.dat reset;
output on;
screen off;
do while i<=nrep;

tsave1[i,.];
i=i+1;
endo;

end;



proc(2) = enfve_2(bcp,bct,x);

local anmat,nv,j,cind,nind,s,an;
anmat=zeros(nd,1);

@ Skip this procedure if either bcpn or bctn contain missing values @
if (scalmiss(bcp) .== 1) .or (scalmiss(bct) .== 1);
 retp(bcp,bct);
endif;

bcp=bcp~ones(rows(bcp),1);
bct=bct~zeros(rows(bct),1);
anmat=sortc((bcp|bct),1);

nv=0;
j=1;do while j <= (rows(anmat)-1);
   bcp=bcp~ones(rows(bcp),1);
   bct=bct~zeros(rows(bct),1);
   anmat=sortc((bcp|bct),1);
   if j+1 .> rows(anmat); break; endif;
  cind=anmat[j,1];nind=anmat[j+1,1];
   if nind-cind .< 4;nv=1;
   if abs(x[nind]-x[cind]) .> .2;
nv=0;
goto skip;
endif;

        if anmat[j+1,2]==1;
an=anmat[j+1,1];


        else;

 endif;
      s=zeros(rows(anmat),1); s[j+1,1]=1; anmat=delif(anmat,s);
      bcp=selif(anmat,anmat[.,2] .> 0);bct=selif(anmat,anmat[.,2] .< 1);
      if (scalmiss(bcp) .== 1) .or (scalmiss(bct) .== 1);
       retp(bcp,bct);
      endif;

      {bcp,bct}=alter2(bcp,bct,x);j=j-1;
   endif;
skip:
j=j+1;endo;

if nv==0; endif;

bcp=bcp[.,1];
bct=bct[.,1];

retp(bcp,bct);
endp;







proc(2) = enf1p(bcp,bct,x);

/*
   Enforce 16 month P-P and T-T cycles.
   If Violated, choose highest peak and lowest trough
*/
local i, s, d1, d2;
@ Check Peak to Peak @
i=2; do while i <= rows(bcp);
  if (bcp[i,1] - bcp[i-1,1]) .< 16;
   s=zeros(rows(bcp),1);
   d1=bcp[i-1,1]; d2=bcp[i,1];
   if x[d1,1] .> x[d2,1]; s[i,1]=1;else;s[i-1,1]=1;endif;
   bcp=delif(bcp,s);
  endif;
i=i+1; endo;
{bcp,bct}=alter2(bcp,bct,x);  @ Impose Alternating P,T @

@ Check Trough to Trough @
i=2; do while i <= rows(bct);
  if (bct[i,1] - bct[i-1,1]) .< 16;
   s=zeros(rows(bct),1);
   d1=bct[i-1,1]; d2=bct[i,1];
   if x[d1,1] .< x[d2,1]; s[i,1]=1;else;s[i-1,1]=1;endif;
   bct=delif(bct,s);
  endif;
i=i+1; endo;
{bcp,bct}=alter2(bcp,bct,x);  @ Impose Alternating P,T @
retp(bcp,bct);
endp;

proc(0) = prdatesp(cal,b);

/* Print Cycle Dates */

local i;

i=1; do while i <= rows(b);
i=i+1; endo;

retp;
endp;
proc(2) = enfvep(bcp,bct,x);
/*
   Eliminate Phases less than 4 months.
   (Save lowest troughs and highest peaks)
*/
local i,s;
top1:
i=1; do while i <= minc(rows(bcp)|rows(bct));
  if abs(bcp[i,1] - bct[i,1]) .< 4;
   if bcp[i,1] .> bct[i,1];  @ Eliminate peak @
    s=zeros(rows(bcp),1);
    s[i,1]=1;
    bcp=delif(bcp,s);
   else;                     @ Eliminate Trough @
    s=zeros(rows(bct),1);
    s[i,1]=1;
    bct=delif(bct,s);
   endif;
   {bcp,bct}=alter2(bcp,bct,x);
   goto top1;
  endif;
i=i+1; endo;

retp(bcp,bct);
endp;


proc(2) = alter2(bcpn,bctn,x);

/* Enforces alternation between Peaks and Troughs */

local anmat,j,cval,nval,s,d1,d2,nv;

@ Skip this procedure if either bcpn or bctn contain missing values @
if (scalmiss(bcpn) .== 1) .or (scalmiss(bctn) .== 1);
 retp(bcpn,bctn);
endif;

bcpn=bcpn~ones(rows(bcpn),1);
bctn=bctn~zeros(rows(bctn),1);
anmat=sortc((bcpn|bctn),1);


nv=0;
j=1; do while j <= (rows(anmat)-1);
  cval=anmat[j,2];
  nval=anmat[j+1,2];
    if nval==cval;
       if cval==1;

          @ -- eliminate lesser of two peaks
            -- in case of eliminate last peak @
          s=zeros(rows(anmat),1);
          d1=anmat[j,1];
          d2=anmat[j+1,1];


          if x[d1,1] .>= x[d2,1]; s[j+1,1]=1;
          else; s[j,1]=1; endif;
          anmat=delif(anmat,s); nv=1;
          j=j-1;
        else;

          @ -- eliminate greater of two troughs
            -- in case of eliminate first trough @
          s=zeros(rows(anmat),1);
          d1=anmat[j,1];
          d2=anmat[j+1,1];
          if x[d1,1] .>= x[d2,1]; s[j,1]=1;
          else; s[j+1,1]=1; endif;
          anmat=delif(anmat,s); nv=1;
          j=j-1;
       endif;
    endif;
j=j+1;
endo;

if nv==0;  endif;

bcpn=selif(anmat,anmat[.,2] .> 0);
bctn=selif(anmat,anmat[.,2] .< 1);

bcpn=bcpn[.,1];
bctn=bctn[.,1];

 retp(bcpn,bctn);
endp;



proc(2) = enfvbp(bcp,bct,x);
/*
   Eliminate Turns with 4 months of beginning and end of series
*/
local s;

@ Check Peaks @
s=zeros(rows(bcp),1);
if bcp[1,1] .<= 4; s[1,1]=1;
endif;
if bcp[rows(bcp),1] .> rows(x)-4; s[rows(bcp),1]=1;
endif;
bcp=delif(bcp,s);

@ Check Troughs @
s=zeros(rows(bct),1);
if bct[1,1] .<= 4; s[1,1]=1;
endif;
if bct[rows(bct),1] .> rows(x)-4; s[rows(bct),1]=1;
endif;
bct=delif(bct,s);

@ Make Sure Dates Alternate @
{bcp,bct}=alter2(bcp,bct,x);

retp(bcp,bct);
endp;

proc(2) = enfvcp(bcp,bct,x);
/*
 Elimination of Peaks (and Troughs) at both ends which are lower (or higher)
 than values closer to end
*/
local m, s, d1;
top:
@ Check First Date @
m=minc(bcp|bct);
if m .== minc(bcp); @ First TP is a peak @
s=zeros(rows(bcp),1);
d1=bcp[1,1];
if x[1,1] .> x[d1,1]; s[1,1]=1;
 bcp=delif(bcp,s); goto top;
endif;

else; @ First TP is a trough @
s=zeros(rows(bct),1);
d1=bct[1,1];
if x[1,1] .< x[d1,1]; s[1,1]=1;
 bct=delif(bct,s); goto top;
endif;

endif;

@ Check last Date @
m=maxc(bcp|bct);
if m .== maxc(bcp); @ Last TP is a peak @
s=zeros(rows(bcp),1);
d1=bcp[rows(bcp),1];
if x[rows(x),1] .> x[d1,1]; s[rows(bcp),1]=1;
 bcp=delif(bcp,s); goto top;
endif;

else; @ last TP is a trough @
s=zeros(rows(bct),1);
d1=bct[rows(bct),1];
if x[rows(x),1] .< x[d1,1]; s[rows(bct),1]=1;
 bct=delif(bct,s); goto top;
endif;
endif;

@ Make Sure Date Alternate @
{bcp,bct}=alter2(bcp,bct,x);

retp(bcp,bct);
endp;





 proc(2) = dates1(x,cal);
/*
   Dates1.gss
   mww, 6/30/91
*/
local peak1, trough1, nd, i;
nd=rows(x);
peak1=zeros(nd,1);
trough1=zeros(nd,1);

@   Step 1;
   Determine dates that are higher than any values 8 months
   Determine dates that are lower  than any values 8 months
   These are initial peak an trough
@

i=9; do while i <= nd-8;
  if x[i,1] .== maxc(x[i-8:i+8,1]); peak1[i,1]=1;
                             endif;
  if x[i,1] .== minc(x[i-8:i+8,1]); trough1[i,1]=1;
                            endif;

i=i+1; endo;
print;

retp(peak1,trough1);
endp;

proc(0) = dates(bcp,bct);

local bp,bt,analmat,j;

@ This procedure takes peak and trough strings and puts turning points @
@ in chronological order for convenient viewing in output file @



bp=bcp~ones(rows(bcp),1);
bt=bct~zeros(rows(bct),1);
analmat=sortc((bp|bt),1);

j=1; do while j <= rows(analmat);
   if analmat[j,2] .== 1;
                               else;

   endif;
j=j+1; endo;

retp;
endp;






proc(0)=findates(x,nd);

local d,peak1,trough1,t,bcp2,bct2;
local bct1,bcp1,bct3,bcp3,bct4,bcp4;
local r, k;
local ntr, npk, v,ic1,ic2;
local td,pd,pdc,tdc,pde,tde,pda,tda,pdea,tdea;
local dp,dt;


@ Set Up Calendar @
d= seqa(0,1,nd+12);
d=(int(d./12)+nsfy)~((d%12)+ones(nd+12,1));
cal=d[nsfm:nd+nsfm-1,.];




@initial dates @

{peak1,trough1}=dates1(x,cal);

t=seqa(1,1,rows(x));
bcp2=selif(t,peak1);
bct2=selif(t,trough1);

@ lot of this is redundant. bcp3 etc could be skipped but are relics of the
old Bry Boschan stages@


prdatesp(cal,bcp2);

prdatesp(cal,bct2);   @ bct2 and bcp2 contain turning points after step 2 @

bcp3=bcp2;bct3=bct2;
             @ B. Enforce 16 month minimum P-P and T-T cycles @
{bcp3,bct3}=enf1p(bcp3,bct3,x);



@step below is not used@
             @ A. Refine Previous Dates to 5 using of x4 @
bcp4=bcp3;bct4=bct3;

@ Step V: Refine these using the actual series @
bcp5=bcp4;bct5=bct4;
             @ B. Eliminate Turns with 4 months of beginning and end
                  of series @
{bcp5,bct5}=enfvbp(bcp5,bct5,x);
             @ C. Elimination of Peaks (and Troughs) at both ends which
               are lower (or higher) than values closer to end @
{bcp5,bct5}=enfvcp(bcp5,bct5,x);
             @ D. Elimination of P-P and T-T cycles less than 16 months @
{bcp5,bct5}=enf1p(bcp5,bct5,x);
             @ E. Eliminate Phases whose duration is less than 4  months @

{bcp5,bct5}=enfve_2(bcp5,bct5,x);


prdatesp(cal,bcp5);

prdatesp(cal,bct5);
dates(bcp5,bct5);

ntr=rows(bct5);npk=rows(bcp5);
pdc=zeros(nd,1);tdc=zeros(nd,1);


@print statistics@



if bcp5[1,1] .< bct5[1,1]; @ Peaks are first @
 r=minc(rows(bcp5)|rows(bct5));
 pd=bct5[1:r,1]-bcp5[1:r,1];

pda=x[bct5[1:r,1]]-x[bcp5[1:r,1]];

k=1;
do while k<=r;

pdc[k]=sumc(x[bcp5[k,1]:bct5[k,1],1]-x[bcp5[k,1],1]);




k=k+1;
endo;


else;                      @ troughs are First @
 r=minc(rows(bcp5)|rows(bct5)-1);

 pd=bct5[2:r+1,1]-bcp5[1:r,1];

pda=x[bct5[2:r+1,1]]-x[bcp5[1:r,1]];


k=1;
do while k<=r;
 pdc[k]=sumc(x[bcp5[k,1]:bct5[k+1,1],1]-x[bcp5[k,1],1]);

k=k+1;
endo;





endif;

@ Calculate Trough to Peak Durations and amplitudes@
if bct5[1,1] .< bcp5[1,1]; @ Troughs are first @
 r=minc(rows(bct5)|rows(bcp5));
 td=bcp5[1:r,1]-bct5[1:r,1];
tda=x[bcp5[1:r,1]]-x[bct5[1:r,1]];


k=1;
do while k<=r;
 tdc[k]=sumc(x[bct5[k,1]:bcp5[k,1],1]-x[bct5[k,1],1]);

k=k+1;
endo;




else;                      @ peaks are First @
 r=minc(rows(bct5)|rows(bcp5)-1);
 td=bcp5[2:r+1,1]-bct5[1:r,1];

tda=x[bcp5[2:r+1,1]]-x[bct5[1:r,1]];


k=1;
do while k<=r;


 tdc[k]=sumc(x[bct5[k,1]:bcp5[k+1,1],1]-x[bct5[k,1],1]);


k=k+1;
endo;



endif;

pdc=pdc[1:rows(pd)];



tdc=tdc[1:rows(td)];


@compute excesses@


v=-.22;


ic1=counts(pda,v)/rows(pda);
v=.18;




ic2=1-(counts(tda,v)/rows(tda));
pde=(pdc-.5*pda-((pd.*pda)/2))./pd;


pdea=abs(pdc-((pd.*pda)/2))./pd;



tde=(tdc-.5*tda-((td.*tda)/2))./td;





@cumulate. When nrep=1 then gives raw data, otherwsise sums over monte
carlo amounts@

@save results for later p value computation@

tsave1[iter,1]=meanc(pd);
tsave1[iter,2]=meanc(td);
tsave1[iter,3]=meanc(pda);
tsave1[iter,4]=meanc(tda);
tsave1[iter,5]=meanc(pdc);
tsave1[iter,6]=meanc(tdc);

tsave1[iter,7]=meanc(pde);
tsave1[iter,8]=meanc(tde);

tsave1[iter,9]=ic1;

tsave1[iter,10]=ic2;



pdm=pdm+meanc(pd);
pdma=pdma+meanc(pda);

tdm=tdm+meanc(td);
tdma=tdma+meanc(tda);

tc1=tc1+ic1;
tc2=tc2+ic2;

pdcm=pdcm+meanc(pdc);
tdcm=tdcm+meanc(tdc);

tdem=tdem+meanc(tde);
pdem=pdem+meanc(pde);


retp;

endp;

proc(2) = rwdata(iseed);

local mn,st,init,e,u,ht,roe,x0;

@random walk case@

e=rndns(nd,1,iseed);
u=zeros(nd,1);ht=zeros(nd,1);


@gordon and st armour implied means and vars@



@  mn=.0001568;st=.028439;init=0;@
@data over their period@

@  mn=.0051;st=.0432;init=0;@

@cc values below@

@mn=.00157;st=.0536;init=0;@

@1889-1997 values@

 mn=.0039;st=.0448;init=0;
@ mn=.00;st=.0448;init=0;@

@GSA sub period@

mn=.0047;st=.0364;init=0;

@CC mean and var use note diff to actual outcomesd@

@mn=.00398;st=.0388;init=0;@


u=e*st;
u=u+mn;
roe=1;
x0=init;
x=recserar(u,x0,roe);
retp(x,iseed);
endp;

proc(2) = garch(iseed);

local mn,e,inith,garint,garar,garma,ht,x0,roe,u,ij;

e=zeros(nd,1);
u=zeros(nd,1);
ht=zeros(nd,1);

garint=.00008678;garar=.83;garma=.13;mn=.0052;
mn=0.0039;


@BE CAREFUL WHEN RUNNING GARCH THAT ALL THINGS ARE SET PROPERLY@
e=rndns(nd,1,iseed);
inith=garint/(1-garar-garma);
ij=2;
u[1]=sqrt(inith)*e[1];
ht[1]=inith;

do while ij<=nd;
ht[ij]=garint+ garar*ht[ij-1]+garma*(u[ij-1]^2);
u[ij]=sqrt(ht[ij])*e[ij];
ij=ij+1;
endo;
u=u+mn;
x0=0;
roe=1;
x=recserar(u,x0,roe);
retp(x,iseed);
endp;

proc(2)= durdep(iseed);

local mu0,mu1,phi1,sig0,sig1,init,g11,g21,g12,g22,nn;
local p,q,nlag,z,v,f,mn,y,x,unprob,a,d,c2,d22,tau,i;
local errors,e;
@duration dependence case@
@g's are from Maheu/McCurdy. mu's and sigs are set up to
produce mean and variance equal to US data from 1875@

mu0=-.004;mu1=.0039;
phi1= 0;
sig0=.09;sig1=.043;
init=0;
g11=-.765;g21=.341;g12=.954;g22=.248;




p=.95;q=.85;
tau=20;

nlag=1;
nn=nd;



z=zeros(nn,1);
v=zeros(nn,1);
f=zeros(nn,1);
mn=zeros(nn,1);
y=zeros(nn,1);
x=zeros(nn,1);
@unprob is uncond prob of getting a value 1 for binary rv@
unprob=(1-q)/(1-p+1-q);

a=rndus(1,1,iseed);
d=0;
z[1]=0;


if a<=unprob;
z[1]=1;

endif;

i=nlag+1;

do while i<=nn;

a=rndus(1,1,iseed);


if z[i-1]==0;


goto nought;
endif;
p=exp(g12+g22*d)/(1+exp(g12+g22*d));
v[i]=-p;
if a<p;
v[i]=1-p;
endif;
goto ender;
nought:
q=exp(g11+g21*d)/(1+exp(g11+g21*d));
v[i]=q;
if a<q;
v[i]=-(1-q);
endif;
ender:
c2=1-q;
d22=p+q-1;
z[i]=c2+d22*z[i-1]+v[i];
z[i]=z[i]+.1;
z[i]=trunc(z[i]);
if z[i]==z[i-1];
d=d+1;


else;
d=0;
endif;
if d>=tau;
d=tau;
endif;

i=i+1;
endo;



mn=(mu1*z)+(mu0*(1-z));

e=rndns(nn,1,iseed);
errors=zeros(nn,1);

x[1]=0;
i=2;
do while i<=nn;
errors[i]=(z[i]*sig1*e[i])+sig0*(1-z[i])*e[i];

f[i]=mn[i]+errors[i];
x[i]=x[i-1]+f[i];

i=i+1;
endo;







retp(x,iseed);
endp;


proc(2)=gordon(iseed);

local t,betta,gama0,gama1,theta,fi,fim,sigma,sig,prob0,prob1,pii;
local id,omega,ome,ddivprev,ddivbar,divprev,divi,index,err,div;
local pibar,r,s,sprev,ss,ddiv,dd,betapi,p0,p1,etctplus1,b00;
local b01,b0,m1,m2,lambda,k,x11,x21,x22,x,var,covar,z,b1,eind,fimi,betai;
local ind,m0,ppi,a,x0,x1,sh,tim,p,gama,b,m,i,pd,pd1;
local e1,roe,divst;

t=nd;
    /*number of observations*/
betta=.9974;    /*discount factor*/

gama0=2.6513;   /*parameters of utility function*/
gama1=2.2059;gama=gama0|gama1;

@gama0=1.8511;   /*parameters of utility function*/
gama1=1.4204;gama=gama0|gama1;@




theta=9.2269;

@fi=.0056313|.0020833; /* vector in c and d VAR */
fim=-.18017~.045|.013~-.225;  /*matrix of c and d VAR */
sigma=0.0001395~-0.000003626|0.00000362~.0000154;@
 /*10 variance of VAR errors*/

fi=-.0000265|.0000265; /* vector in c and d VAR */
fim=.0026~.0661|.0658~-.0206;  /*matrix of c and d VAR */
sigma=0.0000832~0.00000714|0.00000714~.0000449;
/*10 variance of VAR errors*/

/*sigma=.0000837~.0000837|.0000837~.0000837;*/
sig=(sigma[1,1]-sigma[1,2]^2/sigma[2,2])^.5~sigma[1,2]/(sigma[2,2]^.5);
sig=sig|0~sigma[2,2]^.5; /*holesky factor of sigma*/

@prob0=.92;prob1=.8;@

prob0=.9909;prob1=.9939;



pii=prob0~1-prob0|1-prob1~prob1;
/*transition matrix for state of nature process*/
id=1~0|0~1;omega=.03~0|0~.05;
ome=(omega[1,1]-omega[1,2]^2/omega[2,2])^.5~omega[1,2]/(omega[2,2]^.5);
ome=ome|0~omega[2,2]^.5;

/*generate c, d, state of nature*/

ddivprev=inv(id-fim)*fi;ddivbar=ddivprev;   /* uncond mean of ddiv*/
divprev=3|8.2;              /*sets 1st values of div and c*/
divi=divprev;
index=1;    /*20*/
do while index<t;
err=rndns(2,1,iseed);
err=sig*err;                    /*errors of VAR*/
div=divprev+fi+fim*ddivprev+err;        /*generate VAR*/
ddivprev=div-divprev;
divprev=div;
divi=divi~div;
index=index+1;
endo;
div=divi; /*30  div is 2xT matrix of dividents and consumption*/


p=(1-prob1)/(2-prob0-prob1);pibar=p~1-p|p~1-p;
    /*stable prob of state of nature=0 and stable matrix*/
r=rndus(1,1,iseed);        /*random variable to set 1st state of nature*/
if r>p;
s=1;
else;
s=0;
endif;      /*set 1st state of nature according to stable distribution*/
sprev=s;    /*40*/
ss=s;
index=1;
do while index<t;
r=rndus(1,1,iseed);        /*random variable to set state of nature*/
if sprev>0;
if r>pii[2,2];
s=0;
else;
s=1;
endif;  /*50*/
else;
if r>pii[1,1];
s=1;
else;
s=0;
endif;
endif;      /*set next state of nature according to markov rule*/
ss=ss~s;
sprev=s;
index=index+1;  /*60*/
endo;
s=ss;       /*s is 1xT matrix of state of nature*/

/*generate B0 and prices of bond*/
ddiv=ddivbar;   /* set 1st value of dif of (d,c) to unconditional mean*/
index=2;
do while index<(t+1);
dd=div[.,index]-div[.,index-1];
ddiv=ddiv~dd;  /*ddiv is 2xT matrix 1st dif of dividents and consumption*/
index=index+1;  /*70*/
endo;
betapi=betta*pii;
p0=0;p1=0;pd=0;pd1=0;
index=1;
do while index<t+1;             /*for every t*/
etctplus1=fi[2,1]+div[2,index]+fim[2,.]*ddiv[.,index]; /*calculate Etct+1 */
b00=exp(gama0^2*sigma[2,2]/2+gama0*theta-gama0*etctplus1);
b01=exp(gama1^2*sigma[2,2]/2+gama1*theta-gama1*etctplus1);
b0=b00|b01;
b0=betapi*b0;   /*80*/              /*calculate vector B0(t)*/
p=ln(b0[s[1,index]+1,1])+gama[s[1,index]+1,1]*(div[2,index]-theta);
/*calculate price of bond*/
p0=p0~p;                /*p0 is row of bond prices*/
index=index+1;
endo;

/*generate B1 and price of stock*/
{m1,m2}=eigv(fim);lambda=maxc(prob0+prob1-1|abs(m1[1,1])|abs(m1[2,1]));
k=ln(.00001)/ln(lambda);
k=int(k+1);                 /* calculate K*/
x0=1/(1-betta*exp(ddivbar[1,1]-gama0*ddivbar[2,1]));    /*90*/
x1=1/(1-betta*exp(ddivbar[1,1]-gama1*ddivbar[2,1]));
b=ddivbar;
x11=sigma[1,1];x21=sigma[2,1];x22=sigma[2,2];x=sigma;
var=sigma;covar=0~0|0~0;z=id;
index=2;            /*for every i from 2 to K*/
do while index<k+1;
if index<150;z=fim*z;else;z=0~0|0~0;endif;
covar=fim*(covar+var);
var=var+z*sigma*(z');   /*100*/
x=x+covar+var+covar';           /* X is VARt(d,c)t+i*/
x11=x11|x[1,1];x22=x22|x[2,2];x21=x21|x[2,1];
/*x11,x22,x21 -Kx1 columns of elements of x*/
index=index+1;
endo;
index=1;
do while index<t+1;      /*for every t*/
a=ddiv[.,index]-b;
b1=0|0;eind=div[.,index];fimi=id;betai=1;ppi=id;
ind=1;  /*110*/
do while ind<k;         /* for ind up to K-1*/
if ind<150;fimi=fimi*fim;else;fimi=0~0|0~0;endif;
eind=eind+b+fimi*a;
m0=exp(eind[1,1]-gama0*(eind[2,1]-theta));
m0=m0*exp(.5*(x11[ind,1]+gama0^2*x22[ind,1]-2*gama0*x21[ind,1]));
m1=exp(eind[1,1]-gama1*(eind[2,1]-theta));
m1=m1*exp(.5*(x11[ind,1]+gama1^2*x22[ind,1]-2*gama1*x21[ind,1]));
m=m0|m1;
betai=betta*betai;ppi=pii*ppi;b1=b1+betai*ppi*m;
    /*calculate indth partial sum in B1(t)*/
ind=ind+1;
endo;
fimi=fimi*fim;  /*120*/
eind=eind+b+fimi*a;
m0=exp(eind[1,1]-gama0*(eind[2,1]-theta));
m0=m0*exp(.5*(x11[k,1]+gama0^2*x22[k,1]-2*gama0*x21[k,1]));
m1=exp(eind[1,1]-gama1*(eind[2,1]-theta));
m1=m1*exp(.5*(x11[k,1]+gama1^2*x22[k,1]-2*gama1*x21[k,1]));
m=m0*x0|m1*x1;      /*and remaining geometric sum from K*/
betai=betta*betai;b1=b1+betai*pibar*m;  /*find vector B1(t)*/
p=ln(b1[s[1,index]+1,1])+gama[s[1,index]+1,1]*(div[2,index]-theta);
    /* and stock price at t*/
pd=exp(p-ln(div[1,index]));  @compute log price-div ratio@
pd1=pd1~pd;
p1=p1~p;                /*p1 is row of stock prices*/
index=index+1;
endo;


 /*prints state of nature and log of simulated prices of stock*/
tim=1;p=p1[1,2];i=2;do while i<t+1;tim=tim|i;p=p|p1[1,i+1];i=i+1;endo;
tim=1;pd=pd1[1,2];i=2;do while i<t+1;tim=tim|i;pd=pd|pd1[1,i+1];i=i+1;endo;

e1=(.0057/(1.1819))+rndns(nd,1,iseed)*.0118;
divst=1.0;roe=1;
div=recserar(e1,divst,roe);
x=pd.*exp(div);
x=ln(x);

retp(x,iseed);
endp;



proc(2) = egarch(iseed);

local mn,e,inith,garint,garar,garma,ht,x0,roe,u,ij,lht,lev;

e=zeros(nd,1);
u=zeros(nd,1);
ht=zeros(nd,1);
lht=zeros(nd,1);
garint=-.31382;garar=.949;garma=.2583;mn=.00454;lev=-.0605;
mn=.0039;


@BE CAREFUL WHEN RUNNING GARCH THAT ALL THINGS ARE SET PROPERLY@
e=rndns(nd,1,iseed);
inith=exp(garint/(1-garar));
ij=2;
u[1]=sqrt(inith)*e[1];
lht[1]=inith;

do while ij<=nd;
lht[ij]=garint+ garar*lht[ij-1]+garma*(abs(e[ij-1])-.797);
lht[ij]=lht[ij]+lev*e[ij-1];
ht[ij]=exp(lht[ij]);
u[ij]=sqrt(ht[ij])*e[ij];
ij=ij+1;
endo;
u=u+mn;
x0=0;
roe=1;
x=recserar(u,x0,roe);
retp(x,iseed);
endp;

proc(2)=gwthser(iseed);

local roe1,mn,st,e,z,x0,init,roe,i;

z=zeros(nd,1);e=zeros(nd,1);

e=rndns(nd,1,iseed);

mn=.0042;roe1=.9;st=.044*sqrt(1-roe1^2);init=0;








i=2;

do while i<=nd;

z[i]=mn+roe1*z[i-1]+st*e[i];

i=i+1;
endo;
x0=init;

roe=1;

x=recserar(z,x0,roe);



retp(x,iseed);
endp;


proc(2)= ddmsdd(iseed);
/* This program simulates DDMS-DD model from Maheu and McCurdy (2000) */
local reps,mu1,psi1,diff,psi2,phi1,phi2,phi3,phi4,phi5;
local phis,sigs1,zeta1,sigs2,zeta2,g11,g21,g12,g22,tao;
local vt,y0,strand,state4,p00max,p11max,p00,p11,indx,s0,d4;
local ex,ht,ns,temp,z4,d0,nn,x0,roe;


/* Table 5:  MODEL4 ONLY */
/* DDMS-DD */

reps=nd;


mu1=-.014/1.70;
psi1=.00063;
diff=(.029/1.70)-mu1;
psi2=-.001;
phi1=.012;
phi2=-.022;
phi3=-.002;
phi4=.021;
phi5=.08;
phis=phi1|phi2|phi3|phi4|phi5;
sigs1=.175;
zeta1=.014;
sigs2=.201;
zeta2=-.002;
g11=.617;
g21=.085;
g12=1.027;
g22=.122;
tao=16;








/* Simulating DDMS-DD */

vt=rndns(reps,1,iseed);

y0=zeros(1,5);
z4=zeros(reps,1);
strand=rndus(reps,1,iseed);
state4=zeros(reps,1);
d4=zeros(reps,1);                /* duration in state */
d0=1;
s0=1;                           /* start at state 1 */
p00max=exp(g11+(g21*tao))/(1+exp(g11+(g21*tao)));
p11max=exp(g12+(g22*tao))/(1+exp(g12+(g22*tao)));

indx=1;
do while indx <= reps;
    p00=exp(g11+(g21*d0*(1-s0)))/(1+exp(g11+(g21*d0*(1-s0))));
    p11=exp(g12+(g22*d0*s0))/(1+exp(g12+(g22*d0*s0)));
    p00=minc(p00|p00max);
    p11=minc(p11|p11max);
    if s0==0;
        state4[indx]= strand[indx] .> p00;
    else;
        state4[indx]= strand[indx] .< p11;
    endif;
    if s0 .== state4[indx];
        d4[indx]=d0+1;
    else;
        d4[indx]=1;
    endif;
       s0=state4[indx];
    d0=d4[indx];
    indx=indx+1;
    endo;


ex=d4 .> tao;
d4=(d4.*(1-ex))+(tao*ex);

indx=1;
do while indx <= reps;
    ht=((1-state4[indx])*(sigs1+(zeta1*d4[indx])))
        +(state4[indx]*(sigs2+(zeta2*d4[indx])));
    z4[indx]=mu1+(diff*state4[indx])+((1-state4[indx])*psi1*d4[indx])
        +(state4[indx]*d4[indx]*psi2)+(y0*phis)+((ht^2)*vt[indx]);
    temp=z4[indx]-mu1-(diff*state4[indx])
        -((1-state4[indx])*psi1*d4[indx])-(state4[indx]*d4[indx]*psi2);
    y0=shiftr(y0,1,temp);

    indx=indx+1;

    endo;








nn=rows(z4);


ns=nn-1; x0=0;roe=1;
x=recserar(z4,x0,roe);
@meanc(z4);
stdc(z4); @
retp(x,iseed);



endp;
